import java.awt.*;

class Attachee extends Baloune{
    // Baloune attache par une corde, la position initiale est donne par 
    // le point d'attachement et on ne peut la dplacer 
    // qu'en la montant ou la descendant,  moins de couper la corde....
    private int longueurCorde;
    
    Attachee(int x, int y, int rayon, int longueurCorde){
        // x et y du pied de la corde...
        super(x,y-longueurCorde-rayon,rayon);
        this.longueurCorde=longueurCorde;
    }
    
    public String toString(){
        // les x et y seront ceux du centre de la Baloune...
        return super.toString()+"corde="+longueurCorde;
    }
    
    // modifications de comportements de la Baloune 
    public boolean gonfler(int r){
        // gonfler en s'assurant que la corde reste de la mme longueur
        if (super.gonfler(r)) {
            super.deplacer(0,-r);
            return true;
        } else return false;
    }
    
    public void deplacer(int x, int y){
        // empche le dplacement d'une baloune attache en ne faisant rien
    }
    
    public void afficher(Graphics g, String mess){
        // affiche la baloune sans message qui apparait au bas de la corde
        super.afficher(g,"");
        g.drawLine(x,y+rayon,x,y+rayon+longueurCorde);
        g.drawString(mess,x,y+rayon+longueurCorde);
    }
    
    // comportements spcifiques  la baloune attache
    public void couperCorde(){
        // coupe la corde et alors la baloune vient se coller au haut de l'cran
        // si elle n'y tait pas dj
        int dy = rayon-y;
        if (dy<0) super.deplacer(0,dy);
        longueurCorde=0;
    }
    
    public void monter(int dy){
        // monte la baloune en augmentant la valeur de la corde
        // en s'assurant que la longueur de la corde ne devienne pas ngative  
        if (dy<0 && dy < -longueurCorde) dy = -longueurCorde;
        super.deplacer(0,-dy);
        longueurCorde = longueurCorde+dy;
    }
    
    public void descendre(int dy){
        // descendre la baloune en diminuant la valeur de la corde
        monter(-dy);
    }
    
    public boolean cordeTouchee(int x1, int y1){
        // vrifie si le point x1@y1 est trs prs de la corde
        return Math.abs(x-x1)<5 && y+rayon <y1 && y1< y+rayon+longueurCorde;
    }
}
