import java.awt.*;
// exemple d'hritage
class Baloune{
    // baloune gnrique qui sert de base  tout
    protected int x,y,rayon;  // coordonnes du centre
    private int r2,diametre;
	
    Baloune(int x,int y, int rayon){
    	// cration en s'assurant que le rayon est positif
    	// sinon une instance "vide" est cre
        if (rayon>0) {
            this.x=x;
            this.y=y;
            this.rayon=rayon;
            diametre = 2*rayon;
            r2=rayon*rayon;
        }
    }
	
    public String toString(){
        return "Baloune("+x+","+y+","+rayon+")";
    }
	
    public boolean gonfler(int r){
    	// augmente le rayon si la nouvelle valeur reste positive
    	// important car r peut tre ngatif
        int r1 = rayon+r;  
        if (r1>0){  // on garantit que le nouveau rayon reste positif
            rayon =r1;
            diametre = 2*r1;
            r2 = r1*r1;
            return true;
        } else return false; // indique l'chec du gonflage
    }

    public boolean degonfler(int r){
        return gonfler(-r);
    }

    public void deplacer(int dx, int dy){
        x=x+dx;
        y=y+dy;
    }

    public void afficher(Graphics g,String mess){
    	// dessine la baloune avec un message au centre
        g.drawOval(x-rayon,y-rayon,diametre,diametre);
        g.drawString(mess,x,y);
    }
    
    public boolean contient(int px, int py){
    	// vrifie si le point px@py est dans la baloune
        return (px-x)*(px-x)+(py-y)*(py-y) <= r2;
    }
	
    public boolean contient(Baloune b){
    	// vrifie si b est entirement contenu dans la baloune 
        return rayon >= b.rayon +Math.sqrt((b.x-x)*(b.x-x)+(b.y-y)*(b.y-y));
    }

    public boolean touche(Baloune b){
    	// vrifie si b touche partiellement la baloune
        return (b.x-x)*(b.x-x)+(b.y-y)*(b.y-y) 
            <= (rayon+b.rayon)*(rayon+b.rayon);
    }
}
